// Code generated by SQLBoiler (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package postgres

import (
	"bytes"
	"context"
	"reflect"
	"testing"

	"github.com/volatiletech/sqlboiler/boil"
	"github.com/volatiletech/sqlboiler/queries"
	"github.com/volatiletech/sqlboiler/randomize"
	"github.com/volatiletech/sqlboiler/strmangle"
)

var (
	// Relationships sometimes use the reflection helper queries.Equal/queries.Assign
	// so force a package dependency in case they don't.
	_ = queries.Equal
)

func testDrivers(t *testing.T) {
	t.Parallel()

	query := Drivers()

	if query.Query == nil {
		t.Error("expected a query, got nothing")
	}
}

func testDriversDelete(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Driver{}
	if err = randomize.Struct(seed, o, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := o.Delete(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := Drivers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testDriversQueryDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Driver{}
	if err = randomize.Struct(seed, o, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := Drivers().DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := Drivers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testDriversSliceDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Driver{}
	if err = randomize.Struct(seed, o, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := DriverSlice{o}

	if rowsAff, err := slice.DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := Drivers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testDriversExists(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Driver{}
	if err = randomize.Struct(seed, o, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	e, err := DriverExists(ctx, tx, o.ID)
	if err != nil {
		t.Errorf("Unable to check if Driver exists: %s", err)
	}
	if !e {
		t.Errorf("Expected DriverExists to return true, but got false.")
	}
}

func testDriversFind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Driver{}
	if err = randomize.Struct(seed, o, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	driverFound, err := FindDriver(ctx, tx, o.ID)
	if err != nil {
		t.Error(err)
	}

	if driverFound == nil {
		t.Error("want a record, got nil")
	}
}

func testDriversBind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Driver{}
	if err = randomize.Struct(seed, o, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = Drivers().Bind(ctx, tx, o); err != nil {
		t.Error(err)
	}
}

func testDriversOne(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Driver{}
	if err = randomize.Struct(seed, o, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if x, err := Drivers().One(ctx, tx); err != nil {
		t.Error(err)
	} else if x == nil {
		t.Error("expected to get a non nil record")
	}
}

func testDriversAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	driverOne := &Driver{}
	driverTwo := &Driver{}
	if err = randomize.Struct(seed, driverOne, driverDBTypes, false, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}
	if err = randomize.Struct(seed, driverTwo, driverDBTypes, false, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = driverOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = driverTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := Drivers().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 2 {
		t.Error("want 2 records, got:", len(slice))
	}
}

func testDriversCount(t *testing.T) {
	t.Parallel()

	var err error
	seed := randomize.NewSeed()
	driverOne := &Driver{}
	driverTwo := &Driver{}
	if err = randomize.Struct(seed, driverOne, driverDBTypes, false, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}
	if err = randomize.Struct(seed, driverTwo, driverDBTypes, false, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = driverOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = driverTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Drivers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 2 {
		t.Error("want 2 records, got:", count)
	}
}

func driverBeforeInsertHook(ctx context.Context, e boil.ContextExecutor, o *Driver) error {
	*o = Driver{}
	return nil
}

func driverAfterInsertHook(ctx context.Context, e boil.ContextExecutor, o *Driver) error {
	*o = Driver{}
	return nil
}

func driverAfterSelectHook(ctx context.Context, e boil.ContextExecutor, o *Driver) error {
	*o = Driver{}
	return nil
}

func driverBeforeUpdateHook(ctx context.Context, e boil.ContextExecutor, o *Driver) error {
	*o = Driver{}
	return nil
}

func driverAfterUpdateHook(ctx context.Context, e boil.ContextExecutor, o *Driver) error {
	*o = Driver{}
	return nil
}

func driverBeforeDeleteHook(ctx context.Context, e boil.ContextExecutor, o *Driver) error {
	*o = Driver{}
	return nil
}

func driverAfterDeleteHook(ctx context.Context, e boil.ContextExecutor, o *Driver) error {
	*o = Driver{}
	return nil
}

func driverBeforeUpsertHook(ctx context.Context, e boil.ContextExecutor, o *Driver) error {
	*o = Driver{}
	return nil
}

func driverAfterUpsertHook(ctx context.Context, e boil.ContextExecutor, o *Driver) error {
	*o = Driver{}
	return nil
}

func testDriversHooks(t *testing.T) {
	t.Parallel()

	var err error

	ctx := context.Background()
	empty := &Driver{}
	o := &Driver{}

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, o, driverDBTypes, false); err != nil {
		t.Errorf("Unable to randomize Driver object: %s", err)
	}

	AddDriverHook(boil.BeforeInsertHook, driverBeforeInsertHook)
	if err = o.doBeforeInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeInsertHook function to empty object, but got: %#v", o)
	}
	driverBeforeInsertHooks = []DriverHook{}

	AddDriverHook(boil.AfterInsertHook, driverAfterInsertHook)
	if err = o.doAfterInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterInsertHook function to empty object, but got: %#v", o)
	}
	driverAfterInsertHooks = []DriverHook{}

	AddDriverHook(boil.AfterSelectHook, driverAfterSelectHook)
	if err = o.doAfterSelectHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterSelectHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterSelectHook function to empty object, but got: %#v", o)
	}
	driverAfterSelectHooks = []DriverHook{}

	AddDriverHook(boil.BeforeUpdateHook, driverBeforeUpdateHook)
	if err = o.doBeforeUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpdateHook function to empty object, but got: %#v", o)
	}
	driverBeforeUpdateHooks = []DriverHook{}

	AddDriverHook(boil.AfterUpdateHook, driverAfterUpdateHook)
	if err = o.doAfterUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpdateHook function to empty object, but got: %#v", o)
	}
	driverAfterUpdateHooks = []DriverHook{}

	AddDriverHook(boil.BeforeDeleteHook, driverBeforeDeleteHook)
	if err = o.doBeforeDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeDeleteHook function to empty object, but got: %#v", o)
	}
	driverBeforeDeleteHooks = []DriverHook{}

	AddDriverHook(boil.AfterDeleteHook, driverAfterDeleteHook)
	if err = o.doAfterDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterDeleteHook function to empty object, but got: %#v", o)
	}
	driverAfterDeleteHooks = []DriverHook{}

	AddDriverHook(boil.BeforeUpsertHook, driverBeforeUpsertHook)
	if err = o.doBeforeUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpsertHook function to empty object, but got: %#v", o)
	}
	driverBeforeUpsertHooks = []DriverHook{}

	AddDriverHook(boil.AfterUpsertHook, driverAfterUpsertHook)
	if err = o.doAfterUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpsertHook function to empty object, but got: %#v", o)
	}
	driverAfterUpsertHooks = []DriverHook{}
}

func testDriversInsert(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Driver{}
	if err = randomize.Struct(seed, o, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Drivers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testDriversInsertWhitelist(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Driver{}
	if err = randomize.Struct(seed, o, driverDBTypes, true); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Whitelist(driverColumnsWithoutDefault...)); err != nil {
		t.Error(err)
	}

	count, err := Drivers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testDriverToManyDriverTokens(t *testing.T) {
	var err error
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Driver
	var b, c DriverToken

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	if err = randomize.Struct(seed, &b, driverTokenDBTypes, false, driverTokenColumnsWithDefault...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, driverTokenDBTypes, false, driverTokenColumnsWithDefault...); err != nil {
		t.Fatal(err)
	}

	b.DriverID = a.ID
	c.DriverID = a.ID

	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = c.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := a.DriverTokens().All(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	bFound, cFound := false, false
	for _, v := range check {
		if v.DriverID == b.DriverID {
			bFound = true
		}
		if v.DriverID == c.DriverID {
			cFound = true
		}
	}

	if !bFound {
		t.Error("expected to find b")
	}
	if !cFound {
		t.Error("expected to find c")
	}

	slice := DriverSlice{&a}
	if err = a.L.LoadDriverTokens(ctx, tx, false, (*[]*Driver)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if got := len(a.R.DriverTokens); got != 2 {
		t.Error("number of eager loaded records wrong, got:", got)
	}

	a.R.DriverTokens = nil
	if err = a.L.LoadDriverTokens(ctx, tx, true, &a, nil); err != nil {
		t.Fatal(err)
	}
	if got := len(a.R.DriverTokens); got != 2 {
		t.Error("number of eager loaded records wrong, got:", got)
	}

	if t.Failed() {
		t.Logf("%#v", check)
	}
}

func testDriverToManyOffers(t *testing.T) {
	var err error
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Driver
	var b, c Offer

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	if err = randomize.Struct(seed, &b, offerDBTypes, false, offerColumnsWithDefault...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, offerDBTypes, false, offerColumnsWithDefault...); err != nil {
		t.Fatal(err)
	}

	b.DriverID = a.ID
	c.DriverID = a.ID

	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = c.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := a.Offers().All(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	bFound, cFound := false, false
	for _, v := range check {
		if v.DriverID == b.DriverID {
			bFound = true
		}
		if v.DriverID == c.DriverID {
			cFound = true
		}
	}

	if !bFound {
		t.Error("expected to find b")
	}
	if !cFound {
		t.Error("expected to find c")
	}

	slice := DriverSlice{&a}
	if err = a.L.LoadOffers(ctx, tx, false, (*[]*Driver)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if got := len(a.R.Offers); got != 2 {
		t.Error("number of eager loaded records wrong, got:", got)
	}

	a.R.Offers = nil
	if err = a.L.LoadOffers(ctx, tx, true, &a, nil); err != nil {
		t.Fatal(err)
	}
	if got := len(a.R.Offers); got != 2 {
		t.Error("number of eager loaded records wrong, got:", got)
	}

	if t.Failed() {
		t.Logf("%#v", check)
	}
}

func testDriverToManyOrderDeals(t *testing.T) {
	var err error
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Driver
	var b, c OrderDeal

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	if err = randomize.Struct(seed, &b, orderDealDBTypes, false, orderDealColumnsWithDefault...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, orderDealDBTypes, false, orderDealColumnsWithDefault...); err != nil {
		t.Fatal(err)
	}

	b.DriverID = a.ID
	c.DriverID = a.ID

	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = c.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := a.OrderDeals().All(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	bFound, cFound := false, false
	for _, v := range check {
		if v.DriverID == b.DriverID {
			bFound = true
		}
		if v.DriverID == c.DriverID {
			cFound = true
		}
	}

	if !bFound {
		t.Error("expected to find b")
	}
	if !cFound {
		t.Error("expected to find c")
	}

	slice := DriverSlice{&a}
	if err = a.L.LoadOrderDeals(ctx, tx, false, (*[]*Driver)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if got := len(a.R.OrderDeals); got != 2 {
		t.Error("number of eager loaded records wrong, got:", got)
	}

	a.R.OrderDeals = nil
	if err = a.L.LoadOrderDeals(ctx, tx, true, &a, nil); err != nil {
		t.Fatal(err)
	}
	if got := len(a.R.OrderDeals); got != 2 {
		t.Error("number of eager loaded records wrong, got:", got)
	}

	if t.Failed() {
		t.Logf("%#v", check)
	}
}

func testDriverToManyTransports(t *testing.T) {
	var err error
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Driver
	var b, c Transport

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	if err = randomize.Struct(seed, &b, transportDBTypes, false, transportColumnsWithDefault...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, transportDBTypes, false, transportColumnsWithDefault...); err != nil {
		t.Fatal(err)
	}

	b.DriverID = a.ID
	c.DriverID = a.ID

	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = c.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := a.Transports().All(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	bFound, cFound := false, false
	for _, v := range check {
		if v.DriverID == b.DriverID {
			bFound = true
		}
		if v.DriverID == c.DriverID {
			cFound = true
		}
	}

	if !bFound {
		t.Error("expected to find b")
	}
	if !cFound {
		t.Error("expected to find c")
	}

	slice := DriverSlice{&a}
	if err = a.L.LoadTransports(ctx, tx, false, (*[]*Driver)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if got := len(a.R.Transports); got != 2 {
		t.Error("number of eager loaded records wrong, got:", got)
	}

	a.R.Transports = nil
	if err = a.L.LoadTransports(ctx, tx, true, &a, nil); err != nil {
		t.Fatal(err)
	}
	if got := len(a.R.Transports); got != 2 {
		t.Error("number of eager loaded records wrong, got:", got)
	}

	if t.Failed() {
		t.Logf("%#v", check)
	}
}

func testDriverToManyAddOpDriverTokens(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Driver
	var b, c, d, e DriverToken

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, driverDBTypes, false, strmangle.SetComplement(driverPrimaryKeyColumns, driverColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	foreigners := []*DriverToken{&b, &c, &d, &e}
	for _, x := range foreigners {
		if err = randomize.Struct(seed, x, driverTokenDBTypes, false, strmangle.SetComplement(driverTokenPrimaryKeyColumns, driverTokenColumnsWithoutDefault)...); err != nil {
			t.Fatal(err)
		}
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = c.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	foreignersSplitByInsertion := [][]*DriverToken{
		{&b, &c},
		{&d, &e},
	}

	for i, x := range foreignersSplitByInsertion {
		err = a.AddDriverTokens(ctx, tx, i != 0, x...)
		if err != nil {
			t.Fatal(err)
		}

		first := x[0]
		second := x[1]

		if a.ID != first.DriverID {
			t.Error("foreign key was wrong value", a.ID, first.DriverID)
		}
		if a.ID != second.DriverID {
			t.Error("foreign key was wrong value", a.ID, second.DriverID)
		}

		if first.R.Driver != &a {
			t.Error("relationship was not added properly to the foreign slice")
		}
		if second.R.Driver != &a {
			t.Error("relationship was not added properly to the foreign slice")
		}

		if a.R.DriverTokens[i*2] != first {
			t.Error("relationship struct slice not set to correct value")
		}
		if a.R.DriverTokens[i*2+1] != second {
			t.Error("relationship struct slice not set to correct value")
		}

		count, err := a.DriverTokens().Count(ctx, tx)
		if err != nil {
			t.Fatal(err)
		}
		if want := int64((i + 1) * 2); count != want {
			t.Error("want", want, "got", count)
		}
	}
}
func testDriverToManyAddOpOffers(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Driver
	var b, c, d, e Offer

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, driverDBTypes, false, strmangle.SetComplement(driverPrimaryKeyColumns, driverColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	foreigners := []*Offer{&b, &c, &d, &e}
	for _, x := range foreigners {
		if err = randomize.Struct(seed, x, offerDBTypes, false, strmangle.SetComplement(offerPrimaryKeyColumns, offerColumnsWithoutDefault)...); err != nil {
			t.Fatal(err)
		}
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = c.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	foreignersSplitByInsertion := [][]*Offer{
		{&b, &c},
		{&d, &e},
	}

	for i, x := range foreignersSplitByInsertion {
		err = a.AddOffers(ctx, tx, i != 0, x...)
		if err != nil {
			t.Fatal(err)
		}

		first := x[0]
		second := x[1]

		if a.ID != first.DriverID {
			t.Error("foreign key was wrong value", a.ID, first.DriverID)
		}
		if a.ID != second.DriverID {
			t.Error("foreign key was wrong value", a.ID, second.DriverID)
		}

		if first.R.Driver != &a {
			t.Error("relationship was not added properly to the foreign slice")
		}
		if second.R.Driver != &a {
			t.Error("relationship was not added properly to the foreign slice")
		}

		if a.R.Offers[i*2] != first {
			t.Error("relationship struct slice not set to correct value")
		}
		if a.R.Offers[i*2+1] != second {
			t.Error("relationship struct slice not set to correct value")
		}

		count, err := a.Offers().Count(ctx, tx)
		if err != nil {
			t.Fatal(err)
		}
		if want := int64((i + 1) * 2); count != want {
			t.Error("want", want, "got", count)
		}
	}
}
func testDriverToManyAddOpOrderDeals(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Driver
	var b, c, d, e OrderDeal

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, driverDBTypes, false, strmangle.SetComplement(driverPrimaryKeyColumns, driverColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	foreigners := []*OrderDeal{&b, &c, &d, &e}
	for _, x := range foreigners {
		if err = randomize.Struct(seed, x, orderDealDBTypes, false, strmangle.SetComplement(orderDealPrimaryKeyColumns, orderDealColumnsWithoutDefault)...); err != nil {
			t.Fatal(err)
		}
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = c.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	foreignersSplitByInsertion := [][]*OrderDeal{
		{&b, &c},
		{&d, &e},
	}

	for i, x := range foreignersSplitByInsertion {
		err = a.AddOrderDeals(ctx, tx, i != 0, x...)
		if err != nil {
			t.Fatal(err)
		}

		first := x[0]
		second := x[1]

		if a.ID != first.DriverID {
			t.Error("foreign key was wrong value", a.ID, first.DriverID)
		}
		if a.ID != second.DriverID {
			t.Error("foreign key was wrong value", a.ID, second.DriverID)
		}

		if first.R.Driver != &a {
			t.Error("relationship was not added properly to the foreign slice")
		}
		if second.R.Driver != &a {
			t.Error("relationship was not added properly to the foreign slice")
		}

		if a.R.OrderDeals[i*2] != first {
			t.Error("relationship struct slice not set to correct value")
		}
		if a.R.OrderDeals[i*2+1] != second {
			t.Error("relationship struct slice not set to correct value")
		}

		count, err := a.OrderDeals().Count(ctx, tx)
		if err != nil {
			t.Fatal(err)
		}
		if want := int64((i + 1) * 2); count != want {
			t.Error("want", want, "got", count)
		}
	}
}
func testDriverToManyAddOpTransports(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Driver
	var b, c, d, e Transport

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, driverDBTypes, false, strmangle.SetComplement(driverPrimaryKeyColumns, driverColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	foreigners := []*Transport{&b, &c, &d, &e}
	for _, x := range foreigners {
		if err = randomize.Struct(seed, x, transportDBTypes, false, strmangle.SetComplement(transportPrimaryKeyColumns, transportColumnsWithoutDefault)...); err != nil {
			t.Fatal(err)
		}
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = c.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	foreignersSplitByInsertion := [][]*Transport{
		{&b, &c},
		{&d, &e},
	}

	for i, x := range foreignersSplitByInsertion {
		err = a.AddTransports(ctx, tx, i != 0, x...)
		if err != nil {
			t.Fatal(err)
		}

		first := x[0]
		second := x[1]

		if a.ID != first.DriverID {
			t.Error("foreign key was wrong value", a.ID, first.DriverID)
		}
		if a.ID != second.DriverID {
			t.Error("foreign key was wrong value", a.ID, second.DriverID)
		}

		if first.R.Driver != &a {
			t.Error("relationship was not added properly to the foreign slice")
		}
		if second.R.Driver != &a {
			t.Error("relationship was not added properly to the foreign slice")
		}

		if a.R.Transports[i*2] != first {
			t.Error("relationship struct slice not set to correct value")
		}
		if a.R.Transports[i*2+1] != second {
			t.Error("relationship struct slice not set to correct value")
		}

		count, err := a.Transports().Count(ctx, tx)
		if err != nil {
			t.Fatal(err)
		}
		if want := int64((i + 1) * 2); count != want {
			t.Error("want", want, "got", count)
		}
	}
}

func testDriversReload(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Driver{}
	if err = randomize.Struct(seed, o, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = o.Reload(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testDriversReloadAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Driver{}
	if err = randomize.Struct(seed, o, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := DriverSlice{o}

	if err = slice.ReloadAll(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testDriversSelect(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Driver{}
	if err = randomize.Struct(seed, o, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := Drivers().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 1 {
		t.Error("want one record, got:", len(slice))
	}
}

var (
	driverDBTypes = map[string]string{`ID`: `bigint`, `Phone`: `character varying`, `Profile`: `jsonb`, `Rating`: `numeric`, `Lon`: `numeric`, `Lat`: `numeric`}
	_             = bytes.MinRead
)

func testDriversUpdate(t *testing.T) {
	t.Parallel()

	if 0 == len(driverPrimaryKeyColumns) {
		t.Skip("Skipping table with no primary key columns")
	}
	if len(driverColumns) == len(driverPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &Driver{}
	if err = randomize.Struct(seed, o, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Drivers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, driverDBTypes, true, driverPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	if rowsAff, err := o.Update(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only affect one row but affected", rowsAff)
	}
}

func testDriversSliceUpdateAll(t *testing.T) {
	t.Parallel()

	if len(driverColumns) == len(driverPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &Driver{}
	if err = randomize.Struct(seed, o, driverDBTypes, true, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Drivers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, driverDBTypes, true, driverPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	// Remove Primary keys and unique columns from what we plan to update
	var fields []string
	if strmangle.StringSliceMatch(driverColumns, driverPrimaryKeyColumns) {
		fields = driverColumns
	} else {
		fields = strmangle.SetComplement(
			driverColumns,
			driverPrimaryKeyColumns,
		)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	typ := reflect.TypeOf(o).Elem()
	n := typ.NumField()

	updateMap := M{}
	for _, col := range fields {
		for i := 0; i < n; i++ {
			f := typ.Field(i)
			if f.Tag.Get("boil") == col {
				updateMap[col] = value.Field(i).Interface()
			}
		}
	}

	slice := DriverSlice{o}
	if rowsAff, err := slice.UpdateAll(ctx, tx, updateMap); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("wanted one record updated but got", rowsAff)
	}
}

func testDriversUpsert(t *testing.T) {
	t.Parallel()

	if len(driverColumns) == len(driverPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	// Attempt the INSERT side of an UPSERT
	o := Driver{}
	if err = randomize.Struct(seed, &o, driverDBTypes, true); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Upsert(ctx, tx, false, nil, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert Driver: %s", err)
	}

	count, err := Drivers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}

	// Attempt the UPDATE side of an UPSERT
	if err = randomize.Struct(seed, &o, driverDBTypes, false, driverPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	if err = o.Upsert(ctx, tx, true, nil, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert Driver: %s", err)
	}

	count, err = Drivers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}
}
